Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 4647)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 4648)
@@ -775,181 +725,171 @@
 
 ! Description:
-! -----------------------------------------------------------------------------!
-!> Calculation of the stretching factor through an iterative method. Ideas were 
-!> taken from the paper "Regional stretched grid generation and its application
-!> to the NCAR RegCM (1999)". Normally, no analytic solution exists because the
-!> system of equations has two variables (r,l) but four requirements 
-!> (l=integer, r=[0,88;1,2], Eq(6), Eq(5) starting from index j=1) which
-!> results into an overdetermined system. 
-!------------------------------------------------------------------------------!
+! -------------------------------------------------------------------------------------------------!
+!> Calculation of the stretching factor through an iterative method. Ideas were taken from the paper
+!> "Regional stretched grid generation and its application to the NCAR RegCM (1999)". Normally, no
+!> analytic solution exists because the system of equations has two variables (r,l) but four
+!> requirements  (l=integer, r=[0,88;1,2], Eq(6), Eq(5) starting from index j=1) which results into
+!> an overdetermined system.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE calculate_stretching_factor( number_end )
- 
-    USE control_parameters,                                                    &
-        ONLY:  dz, dz_stretch_factor_array,                 &
-               dz_stretch_level_end, dz_stretch_level_start, message_string
-  
+
+    USE control_parameters,                                                                        &
+        ONLY:  dz, dz_stretch_factor_array, dz_stretch_level_end, dz_stretch_level_start,          &
+               message_string
+
     USE kinds
-    
+
     IMPLICIT NONE
-    
-    INTEGER(iwp) ::  iterations  !< number of iterations until stretch_factor_lower/upper_limit is reached  
-    INTEGER(iwp) ::  l_rounded   !< after l_rounded grid levels dz(n) is strechted to dz(n+1) with stretch_factor_2 
+
+    REAL(wp), PARAMETER ::  stretch_factor_interval = 1.0E-06_wp  !< interval for sampling possible stretching factors
+    REAL(wp), PARAMETER ::  stretch_factor_lower_limit = 0.88_wp  !< lowest possible stretching factor
+    REAL(wp), PARAMETER ::  stretch_factor_upper_limit = 1.12_wp  !< highest possible stretching factor
+
+    INTEGER(iwp) ::  iterations  !< number of iterations until stretch_factor_lower/upper_limit is reached
+    INTEGER(iwp) ::  l_rounded   !< after l_rounded grid levels dz(n) is strechted to dz(n+1) with stretch_factor_2
     INTEGER(iwp) ::  n           !< loop variable for stretching
-    
+
     INTEGER(iwp), INTENT(IN) ::  number_end !< number of user-specified end levels for stretching
-        
+
     REAL(wp) ::  delta_l               !< absolute difference between l and l_rounded
     REAL(wp) ::  delta_stretch_factor  !< absolute difference between stretch_factor_1 and stretch_factor_2
-    REAL(wp) ::  delta_total_new       !< sum of delta_l and delta_stretch_factor for the next iteration (should be as small as possible) 
-    REAL(wp) ::  delta_total_old       !< sum of delta_l and delta_stretch_factor for the last iteration 
+    REAL(wp) ::  delta_total_new       !< sum of delta_l and delta_stretch_factor for the next iteration (should be as small as
+                                       !< possible)
+    REAL(wp) ::  delta_total_old       !< sum of delta_l and delta_stretch_factor for the last iteration
     REAL(wp) ::  distance              !< distance between dz_stretch_level_start and dz_stretch_level_end (stretching region)
-    REAL(wp) ::  l                     !< value that fulfil Eq. (5) in the paper mentioned above together with stretch_factor_1 exactly
+    REAL(wp) ::  l                     !< value that fulfil Eq. (5) in the paper mentioned above together with stretch_factor_1
+                                       !< exactly
     REAL(wp) ::  numerator             !< numerator of the quotient
     REAL(wp) ::  stretch_factor_1      !< stretching factor that fulfil Eq. (5) togehter with l exactly
     REAL(wp) ::  stretch_factor_2      !< stretching factor that fulfil Eq. (6) togehter with l_rounded exactly
-    
-    REAL(wp) ::  dz_stretch_factor_array_2(9) = 1.08_wp  !< Array that contains all stretch_factor_2 that belongs to stretch_factor_1 
-    
-    REAL(wp), PARAMETER ::  stretch_factor_interval = 1.0E-06_wp  !< interval for sampling possible stretching factors
-    REAL(wp), PARAMETER ::  stretch_factor_lower_limit = 0.88_wp  !< lowest possible stretching factor
-    REAL(wp), PARAMETER ::  stretch_factor_upper_limit = 1.12_wp  !< highest possible stretching factor
- 
- 
+
+    REAL(wp) ::  dz_stretch_factor_array_2(9) = 1.08_wp  !< Array that contains all stretch_factor_2 that belongs to
+                                                         !< stretch_factor_1
+
+
     l = 0
     DO  n = 1, number_end
-    
+
        iterations = 1
-       stretch_factor_1 = 1.0_wp 
+       stretch_factor_1 = 1.0_wp
        stretch_factor_2 = 1.0_wp
        delta_total_old = 1.0_wp
-       
+
 !
 !--    First branch for stretching from rough to fine
-       IF ( dz(n) > dz(n+1) ) THEN
-          DO WHILE ( stretch_factor_1 >= stretch_factor_lower_limit ) 
-             
+       IF ( dz(n) > dz(n+1) )  THEN
+          DO WHILE ( stretch_factor_1 >= stretch_factor_lower_limit )
+
              stretch_factor_1 = 1.0_wp - iterations * stretch_factor_interval
-             distance = ABS( dz_stretch_level_end(n) -                         &
-                        dz_stretch_level_start(n) )   
-             numerator = distance*stretch_factor_1/dz(n) +                     &
-                         stretch_factor_1 - distance/dz(n)
-             
-             IF ( numerator > 0.0_wp ) THEN
+             distance = ABS( dz_stretch_level_end(n) - dz_stretch_level_start(n) )
+             numerator = distance * stretch_factor_1 / dz(n) + stretch_factor_1 - distance / dz(n)
+
+             IF ( numerator > 0.0_wp )  THEN
                 l = LOG( numerator ) / LOG( stretch_factor_1 ) - 1.0_wp
                 l_rounded = NINT( l )
                 delta_l = ABS( l_rounded - l ) / l
              ENDIF
-             
+
              stretch_factor_2 = EXP( LOG( dz(n+1)/dz(n) ) / (l_rounded) )
-             
-             delta_stretch_factor = ABS( stretch_factor_1 -                    &
-                                         stretch_factor_2 ) /                  &
-                                    stretch_factor_2
-             
+
+             delta_stretch_factor = ABS( stretch_factor_1 - stretch_factor_2 ) / stretch_factor_2
+
              delta_total_new = delta_l + delta_stretch_factor
 
 !
-!--          stretch_factor_1 is taken to guarantee that the stretching
-!--          procedure ends as close as possible to dz_stretch_level_end.
-!--          stretch_factor_2 would guarantee that the stretched dz(n) is
-!--          equal to dz(n+1) after l_rounded grid levels.
-             IF (delta_total_new < delta_total_old) THEN
+!--          stretch_factor_1 is taken to guarantee that the stretching procedure ends as close as
+!--          possible to dz_stretch_level_end.
+!--          stretch_factor_2 would guarantee that the stretched dz(n) is equal to dz(n+1) after
+!--          l_rounded grid levels.
+             IF (delta_total_new < delta_total_old)  THEN
                 dz_stretch_factor_array(n) = stretch_factor_1
                 dz_stretch_factor_array_2(n) = stretch_factor_2
                 delta_total_old = delta_total_new
              ENDIF
-             
+
              iterations = iterations + 1
-            
+
           ENDDO
 
 !
 !--    Second branch for stretching from fine to rough
-       ELSEIF ( dz(n) < dz(n+1) ) THEN 
+       ELSEIF ( dz(n) < dz(n+1) )  THEN
           DO WHILE ( stretch_factor_1 <= stretch_factor_upper_limit )
-                     
+
              stretch_factor_1 = 1.0_wp + iterations * stretch_factor_interval
-             distance = ABS( dz_stretch_level_end(n) -                         &
-                        dz_stretch_level_start(n) ) 
-             numerator = distance*stretch_factor_1/dz(n) +                     &
-                         stretch_factor_1 - distance/dz(n)
-             
+             distance = ABS( dz_stretch_level_end(n) - dz_stretch_level_start(n) )
+             numerator = distance * stretch_factor_1 / dz(n) + stretch_factor_1 - distance / dz(n)
+
              l = LOG( numerator ) / LOG( stretch_factor_1 ) - 1.0_wp
              l_rounded = NINT( l )
              delta_l = ABS( l_rounded - l ) / l
-             
+
              stretch_factor_2 = EXP( LOG( dz(n+1)/dz(n) ) / (l_rounded) )
 
-             delta_stretch_factor = ABS( stretch_factor_1 -                    &
-                                        stretch_factor_2 ) /                   &
-                                        stretch_factor_2
-             
+             delta_stretch_factor = ABS( stretch_factor_1 - stretch_factor_2 ) / stretch_factor_2
+
              delta_total_new = delta_l + delta_stretch_factor
-             
-!
-!--          stretch_factor_1 is taken to guarantee that the stretching
-!--          procedure ends as close as possible to dz_stretch_level_end.
-!--          stretch_factor_2 would guarantee that the stretched dz(n) is
-!--          equal to dz(n+1) after l_rounded grid levels.
-             IF (delta_total_new < delta_total_old) THEN
+
+!
+!--          stretch_factor_1 is taken to guarantee that the stretching procedure ends as close as
+!--          possible to dz_stretch_level_end.
+!--          stretch_factor_2 would guarantee that the stretched dz(n) is equal to dz(n+1) after
+!--          l_rounded grid levels.
+             IF (delta_total_new < delta_total_old)  THEN
                 dz_stretch_factor_array(n) = stretch_factor_1
                 dz_stretch_factor_array_2(n) = stretch_factor_2
                 delta_total_old = delta_total_new
              ENDIF
-             
+
              iterations = iterations + 1
           ENDDO
-          
+
        ELSE
           message_string= 'Two adjacent values of dz must be different'
           CALL message( 'init_grid', 'PA0228', 1, 2, 0, 6, 0 )
-          
-       ENDIF
-
-!
-!--    Check if also the second stretching factor fits into the allowed
-!--    interval. If not, print a warning for the user.
-       IF ( dz_stretch_factor_array_2(n) < stretch_factor_lower_limit .OR.     & 
-            dz_stretch_factor_array_2(n) > stretch_factor_upper_limit ) THEN
-          WRITE( message_string, * ) 'stretch_factor_2 = ',                    &
-                                     dz_stretch_factor_array_2(n), ' which is',&
-                                     ' responsible for exactly reaching& dz =',&
-                                      dz(n+1), 'after a specific amount of',   & 
-                                     ' grid levels& exceeds the upper',        &
-                                     ' limit =', stretch_factor_upper_limit,   &
-                                     ' &or lower limit = ',                    &
-                                     stretch_factor_lower_limit
+
+       ENDIF
+
+!
+!--    Check if also the second stretching factor fits into the allowed interval. If not, print a
+!--    warning for the user.
+       IF ( dz_stretch_factor_array_2(n) < stretch_factor_lower_limit  .OR.                        &
+            dz_stretch_factor_array_2(n) > stretch_factor_upper_limit )  THEN
+          WRITE( message_string, * ) 'stretch_factor_2 = ', dz_stretch_factor_array_2(n),          &
+                                     ' which is', ' responsible for exactly reaching& dz =',       &
+                                      dz(n+1), 'after a specific amount of',                       &
+                                     ' grid levels& exceeds the upper',                            &
+                                     ' limit =', stretch_factor_upper_limit,                       &
+                                     ' &or lower limit = ', stretch_factor_lower_limit
           CALL message( 'init_grid', 'PA0499', 0, 1, 0, 6, 0 )
-            
+
        ENDIF
     ENDDO
-        
+
  END SUBROUTINE calculate_stretching_factor
- 
- 
+
+
 ! Description:
-! -----------------------------------------------------------------------------!
-!> Set temporary topography flags and reference buildings on top of underlying
-!> orography. 
-!------------------------------------------------------------------------------!
+! -------------------------------------------------------------------------------------------------!
+!> Set temporary topography flags and reference buildings on top of underlying orography.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE process_topography( topo_3d )
 
-    USE arrays_3d,                                                             &
+    USE arrays_3d,                                                                                 &
         ONLY:  zu, zw
 
-    USE control_parameters,                                                    &
+    USE control_parameters,                                                                        &
         ONLY:  bc_lr_cyc, bc_ns_cyc, ocean_mode
 
-    USE exchange_horiz_mod,                                                    &
-        ONLY:  exchange_horiz_int, exchange_horiz_2d
-
-    USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb,  &
-               nzt
-
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  buildings_f, building_id_f, building_type_f,                    &
-               init_model,                                                     &
-               input_pids_static,                                              &
+    USE exchange_horiz_mod,                                                                        &
+        ONLY:  exchange_horiz_2d, exchange_horiz_int
+
+    USE indices,                                                                                   &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb, nzt
+
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  buildings_f, building_id_f, building_type_f,                                        &
+               init_model,                                                                         &
+               input_pids_static,                                                                  &
                terrain_height_f
 
@@ -972,5 +912,6 @@
 #endif
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids           !< building IDs on entire model domain
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_final     !< building IDs on entire model domain, multiple occurences are sorted out 
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_final     !< building IDs on entire model domain, multiple occurences are
+                                                                    !< sorted out
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_final_tmp !< temporary array used for resizing
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_l         !< building IDs on local subdomain
@@ -980,23 +921,26 @@
     INTEGER(iwp), DIMENSION(0:numprocs-1) ::  num_buildings_l   !< number of buildings with different ID on local subdomain
 
-    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  topo_3d !< input array for 3D topography and dummy array for setting "outer"-flags
-
-    REAL(wp)                            ::  ocean_offset        !< offset to consider inverse vertical coordinate at topography definition
-    REAL(wp)                            ::  oro_min = 0.0_wp    !< minimum terrain height in entire model domain, used to reference terrain to zero
+    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  topo_3d !< input array for 3D topography and dummy array for setting
+                                                                       !< "outer"-flags
+
+    REAL(wp)                            ::  ocean_offset        !< offset to consider inverse vertical coordinate at topography
+                                                                !< definition
+    REAL(wp)                            ::  oro_min = 0.0_wp    !< minimum terrain height in entire model domain, used to reference
+                                                                !< terrain to zero
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  oro_max             !< maximum terrain height occupied by an building with certain id
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  oro_max_l           !< maximum terrain height occupied by an building with certain id, on local subdomain
-
-!
-!-- Reference lowest terrain height to zero. This ensures that first, 
-!-- non-required gird levels (those which lie entirely below the minimum 
-!-- orography) are avoided, and second, that also negative orography can be used
-!-- within the input file.
-!-- Please note, in case of a nested run, the global minimum from all parent and 
-!-- childs need to be remove to avoid steep edges at the child-domain boundaries.
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  oro_max_l           !< maximum terrain height occupied by an building with certain id,
+                                                                !< on local subdomain
+
+!
+!-- Reference lowest terrain height to zero. This ensures that first, non-required gird levels
+!-- (those which lie entirely below the minimum orography) are avoided, and second, that also
+!-- negative orography can be used within the input file.
+!-- Please note, in case of a nested run, the global minimum from all parent and childs needs to be
+!-- removed to avoid steep edges at the child-domain boundaries.
     IF ( input_pids_static )  THEN
-    
-#if defined( __parallel ) 
-       CALL MPI_ALLREDUCE( MINVAL( terrain_height_f%var ), oro_min, 1,         &
-                           MPI_REAL, MPI_MIN, MPI_COMM_WORLD, ierr )
+
+#if defined( __parallel )
+       CALL MPI_ALLREDUCE( MINVAL( terrain_height_f%var ), oro_min, 1, MPI_REAL, MPI_MIN,          &
+                           MPI_COMM_WORLD, ierr )
 #else
        oro_min = MINVAL( terrain_height_f%var )
@@ -1007,54 +951,49 @@
        init_model%origin_z = init_model%origin_z + oro_min
 
-    ENDIF    
-    
-!
-!-- In the following, buildings and orography are further preprocessed 
-!-- before they are mapped on the LES grid.
-!-- Buildings are mapped on top of the orography by maintaining the roof 
-!-- shape of the building. This can be achieved by referencing building on 
-!-- top of the maximum terrain height within the area occupied by the 
-!-- respective building. As buildings and terrain height are defined PE-wise,
-!-- parallelization of this referencing is required (a building can be 
-!-- distributed between different PEs).  
-!-- In a first step, determine the number of buildings with different 
-!-- building id on each PE. In a next step, all building ids are gathered
-!-- into one array which is present to all PEs. For each building ID, 
-!-- the maximum terrain height occupied by the respective building is 
-!-- computed and distributed to each PE.  
-!-- Finally, for each building id and its respective reference orography, 
-!-- builidings are mapped on top.   
-!-- 
-!-- First, pre-set topography flags, bit 1 indicates orography, bit 2 
-!-- buildings 
-!-- classify the respective surfaces.
+    ENDIF
+
+!
+!-- In the following, buildings and orography are further preprocessed before they are mapped on the
+!-- LES grid.
+!-- Buildings are mapped on top of the orography by maintaining the roof shape of the building. This
+!-- can be achieved by referencing building on top of the maximum terrain height within the area
+!-- occupied by the respective building. As buildings and terrain height are defined PE-wise,
+!-- parallelization of this referencing is required (a building can be distributed between different
+!-- PEs).
+!-- In a first step, determine the number of buildings with different building id on each PE. In a
+!-- next step, all building ids are gathered into one array which is present to all PEs. For each
+!-- building ID, the maximum terrain height occupied by the respective building is computed and
+!-- distributed to each PE.
+!-- Finally, for each building id and its respective reference orography, builidings are mapped on
+!-- top.
+!--
+!-- First, pre-set topography flags, bit 1 indicates orography, bit 2 buildings classify the
+!-- respective surfaces.
     topo_3d          = IBSET( topo_3d, 0 )
     topo_3d(nzb,:,:) = IBCLR( topo_3d(nzb,:,:), 0 )
 !
-!-- In order to map topography on PALM grid also in case of ocean simulations,
-!-- pre-calculate an offset value.
+!-- In order to map topography on PALM grid also in case of ocean simulations, pre-calculate an
+!-- offset value.
     ocean_offset = MERGE( zw(0), 0.0_wp, ocean_mode )
 !
-!-- Reference buildings on top of orography. This is not necessary
-!-- if topography is read from ASCII file as no distinction between buildings
-!-- and terrain height can be made. Moreover, this is also not necessary if
-!-- urban-surface and land-surface model are used at the same time. 
+!-- Reference buildings on top of orography. This is not necessary if topography is read from ASCII
+!-- file as no distinction between buildings and terrain height can be made. Moreover, this is also
+!-- not necessary if urban-surface and land-surface model are used at the same time.
     IF ( input_pids_static )  THEN
 
-       IF ( buildings_f%from_file )  THEN 
+       IF ( buildings_f%from_file )  THEN
           num_buildings_l = 0
           num_buildings   = 0
 !
-!--       Allocate at least one element for building ids and give it an inital
-!--       negative value that will be overwritten later. This, however, is 
-!--       necessary in case there all IDs in the model domain are fill values. 
+!--       Allocate at least one element for building ids and give it an inital negative value that
+!--       will be overwritten later. This, however, is necessary in case there all IDs in the model
+!--       domain are fill values.
           ALLOCATE( build_ids_l(1) )
-          build_ids_l = -1 
+          build_ids_l = -1
           DO  i = nxl, nxr
              DO  j = nys, nyn
                 IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
                    IF ( num_buildings_l(myid) > 0 )  THEN
-                      IF ( ANY( building_id_f%var(j,i) ==  build_ids_l ) )   &
-                      THEN
+                      IF ( ANY( building_id_f%var(j,i) ==  build_ids_l ) )  THEN
                          CYCLE
                       ELSE
@@ -1066,12 +1005,12 @@
                       DEALLOCATE( build_ids_l )
                       ALLOCATE( build_ids_l(1:num_buildings_l(myid)) )
-                      build_ids_l(1:num_buildings_l(myid)-1) =                 &
-                                  build_ids_l_tmp(1:num_buildings_l(myid)-1)
+                      build_ids_l(1:num_buildings_l(myid)-1) =                                     &
+                                                          build_ids_l_tmp(1:num_buildings_l(myid)-1)
                       build_ids_l(num_buildings_l(myid)) = building_id_f%var(j,i)
                       DEALLOCATE( build_ids_l_tmp )
                    ENDIF
 !
-!--                First occuring building id on PE 
-                   ELSE 
+!--                First occuring building id on PE
+                   ELSE
                       num_buildings_l(myid) = num_buildings_l(myid) + 1
                       build_ids_l(1) = building_id_f%var(j,i)
@@ -1081,23 +1020,21 @@
           ENDDO
 !
-!--       Determine number of different building ids for the entire domain 
-#if defined( __parallel ) 
-          CALL MPI_ALLREDUCE( num_buildings_l, num_buildings, numprocs,              &
-                              MPI_INTEGER, MPI_SUM, comm2d, ierr ) 
+!--       Determine number of different building ids for the entire domain
+#if defined( __parallel )
+          CALL MPI_ALLREDUCE( num_buildings_l, num_buildings, numprocs, MPI_INTEGER, MPI_SUM,      &
+                              comm2d, ierr )
 #else
           num_buildings = num_buildings_l
 #endif
 !
-!--       Gather all buildings ids on each PEs. 
-!--       First, allocate array encompassing all building ids in model domain.  
+!--       Gather all buildings ids on each PEs.
+!--       First, allocate array encompassing all building ids in model domain.
           ALLOCATE( build_ids(1:SUM(num_buildings)) )
-#if defined( __parallel ) 
-!
-!--       Allocate array for displacements. 
-!--       As each PE may has a different number of buildings, so that
-!--       the block sizes send by each PE may not be equal. Hence, 
-!--       information about the respective displacement is required, indicating 
-!--       the respective adress where each MPI-task writes into the receive 
-!--       buffer array  
+#if defined( __parallel )
+!
+!--       Allocate array for displacements.
+!--       As each PE may has a different number of buildings, so that the block sizes send by each
+!--       PE may not be equal. Hence,  information about the respective displacement is required,
+!--       indicating the respective adress where each MPI-task writes into the receive buffer array.
           ALLOCATE( displace_dum(0:numprocs-1) )
           displace_dum(0) = 0
@@ -1106,12 +1043,7 @@
           ENDDO
 
-          CALL MPI_ALLGATHERV( build_ids_l(1:num_buildings_l(myid)),                 &
-                               num_buildings(myid),                                  &
-                               MPI_INTEGER,                                          &
-                               build_ids,                                            &
-                               num_buildings,                                        &
-                               displace_dum,                                         & 
-                               MPI_INTEGER,                                          &
-                               comm2d, ierr )   
+          CALL MPI_ALLGATHERV( build_ids_l(1:num_buildings_l(myid)), num_buildings(myid),          &
+                               MPI_INTEGER, build_ids, num_buildings, displace_dum, MPI_INTEGER,   &
+                               comm2d, ierr )
 
           DEALLOCATE( displace_dum )
@@ -1122,7 +1054,6 @@
 
 !
-!--       Note, in parallel mode building ids can occure mutliple times, as 
-!--       each PE has send its own ids. Therefore, sort out building ids which 
-!--       appear more than one time. 
+!--       Note, in parallel mode building ids can occure mutliple times, as each PE has send its own
+!--       ids. Therefore, sort out building ids which appear more than one time.
           num_build = 0
           DO  nr = 1, SIZE(build_ids)
@@ -1142,5 +1073,5 @@
                    build_ids_final(num_build) = build_ids(nr)
                    DEALLOCATE( build_ids_final_tmp )
-                ENDIF             
+                ENDIF
              ELSE
                 num_build = num_build + 1
@@ -1151,6 +1082,6 @@
 
 !
-!--       Determine maximumum terrain height occupied by the respective 
-!--       building and temporalily store on oro_max 
+!--       Determine maximumum terrain height occupied by the respective building and temporalily
+!--       store on oro_max.
           ALLOCATE( oro_max_l(1:SIZE(build_ids_final)) )
           ALLOCATE( oro_max(1:SIZE(build_ids_final))   )
@@ -1158,15 +1089,14 @@
 
           DO  nr = 1, SIZE(build_ids_final)
-             oro_max_l(nr) = MAXVAL(                                           &
-                              MERGE( terrain_height_f%var(nys:nyn,nxl:nxr),    &
-                                     0.0_wp,                                   &
-                                     building_id_f%var(nys:nyn,nxl:nxr) ==     &
-                                     build_ids_final(nr) ) )
-          ENDDO
-   
-#if defined( __parallel )    
-          IF ( SIZE(build_ids_final) >= 1 ) THEN
-             CALL MPI_ALLREDUCE( oro_max_l, oro_max, SIZE( oro_max ), MPI_REAL,&
-                                 MPI_MAX, comm2d, ierr ) 
+             oro_max_l(nr) = MAXVAL( MERGE( terrain_height_f%var(nys:nyn,nxl:nxr),                 &
+                                              0.0_wp,                                              &
+                                              building_id_f%var(nys:nyn,nxl:nxr) ==                &
+                                              build_ids_final(nr) ) )
+          ENDDO
+
+#if defined( __parallel )
+          IF ( SIZE(build_ids_final) >= 1 )  THEN
+             CALL MPI_ALLREDUCE( oro_max_l, oro_max, SIZE( oro_max ), MPI_REAL, MPI_MAX, comm2d,   &
+                                 ierr )
           ENDIF
 #else
@@ -1174,14 +1104,12 @@
 #endif
 !
-!--       Finally, determine discrete grid height of maximum orography occupied
-!--       by a building. Use all-or-nothing approach, i.e. if terrain
-!--       exceeds the scalar level the grid box is fully terrain and the 
-!--       maximum terrain is set to the zw level. 
-!--       terrain or 
+!--       Finally, determine discrete grid height of maximum orography occupied by a building. Use
+!--       all-or-nothing approach, i.e. if terrain exceeds the scalar level the grid box is fully
+!--       terrain and the maximum terrain is set to the zw level.
+!--       terrain or
           oro_max_l = 0.0
           DO  nr = 1, SIZE(build_ids_final)
              DO  k = nzb, nzt
-                IF ( zu(k) - ocean_offset <= oro_max(nr) )                     &
-                   oro_max_l(nr) = zw(k) - ocean_offset
+                IF ( zu(k) - ocean_offset <= oro_max(nr) )  oro_max_l(nr) = zw(k) - ocean_offset
              ENDDO
              oro_max(nr) = oro_max_l(nr)
@@ -1195,5 +1123,5 @@
        END IF
 !
-!--    Map orography as well as buildings onto grid. 
+!--    Map orography as well as buildings onto grid.
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -1204,8 +1132,7 @@
                 IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
 !
-!--                Determine index where maximum terrain height occupied by 
-!--                the respective building height is stored.
-                   nr = MINLOC( ABS( build_ids_final -                         &
-                                     building_id_f%var(j,i) ), DIM = 1 )
+!--                Determine index where maximum terrain height occupied by the respective building
+!--                height is stored.
+                   nr = MINLOC( ABS( build_ids_final - building_id_f%var(j,i) ), DIM=1 )
 !
 !--                Save grid-indexed oro_max
